"{ Package: 'stx:libjava' }"

JavaClassReader subclass:#JavaClassReader2
	instanceVariableNames:''
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Support'
!


!JavaClassReader2 class methodsFor:'initialization'!

initialize
    super initialize.

    "Created: / 09-05-2011 / 23:20:44 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 10-05-2011 / 14:40:08 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassReader2 methodsFor:'file reading - constants'!

readConstant_Class
    | nameIndex |

    nameIndex := inStream nextUnsignedShortMSB: msb.
    ((constants at: nameIndex) isNil) 
        ifTrue: 
            [ self info: ('reading class; index=' , nameIndex printString , ' name=' 
                        , (constants at: nameIndex) printString) ]
        ifFalse: [ self info: ('reading class; index= ' , nameIndex printString) ].
    ^ JavaClassRef2 in: constants withNameAt: nameIndex.

    "Modified: / 10-05-2011 / 17:09:06 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_Fieldref
    | classIndex  nameAndTypeIndex  class  nameAndType |

    classIndex := inStream nextUnsignedShortMSB: msb.
    nameAndTypeIndex := inStream nextUnsignedShortMSB: msb.
    class := constants at: classIndex.
    nameAndType := constants at: nameAndTypeIndex.
    self 
        info: 'reading fieldref; classindex=' , classIndex printString , ' class=' 
                , class printString , ' nameAndTypeIndex=' 
                , nameAndTypeIndex printString , ' nameAndType=' 
                , nameAndType printString.
    ^ JavaFieldRef2 
                in: constants
                namedAndTyped: nameAndType
                inClassIdentifiedByRef: class.

    "Modified: / 10-05-2011 / 17:09:18 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_InterfaceMethodref
    | classIndex  nameAndTypeIndex  class  nameAndType |

    classIndex := inStream nextUnsignedShortMSB: msb.
    nameAndTypeIndex := inStream nextUnsignedShortMSB: msb.
    class := constants at: classIndex.
    nameAndType := constants at: nameAndTypeIndex.
    self 
        info: 'reading interface methodref; classindex=' , classIndex printString 
                , ' class=' , class printString 
                , ' nameAndTypeIndex=' , nameAndTypeIndex printString 
                , ' nameAndType=' , nameAndType printString.
    ^ JavaInterfaceMethodRef2 
                in: constants
                namedAndTyped: nameAndType
                inClassIdentifiedByRef: class.

    "Modified: / 10-05-2011 / 17:09:26 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_Methodref
    | classIndex  nameAndTypeIndex  class  nameAndType |

    classIndex := inStream nextUnsignedShortMSB: msb.
    nameAndTypeIndex := inStream nextUnsignedShortMSB: msb.
    class := constants at: classIndex.
    nameAndType := constants at: nameAndTypeIndex.
    self 
        info: 'reading methodref; classindex=' , classIndex printString , ' class=' 
                , class printString , ' nameAndTypeIndex=' 
                , nameAndTypeIndex printString , ' nameAndType=' 
                , nameAndType printString.
   ^ JavaMethodRef2 
                in: constants
                namedAndTyped: nameAndType
                inClassIdentifiedByRef: class.

    "Modified: / 10-05-2011 / 17:09:38 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

readConstant_NameAndType
    | nameIndex  descriptorIndex |

    nameIndex := inStream nextUnsignedShortMSB: msb.
    descriptorIndex := inStream nextUnsignedShortMSB: msb.
    self 
        info: 'reading nameAndType; nameindex=' , nameIndex printString 
                , ' descriptorIndex= ' , descriptorIndex printString.
    ^JavaNameAndType2 
                in: constants
                withNameAt: nameIndex
                andDescriptorAt: descriptorIndex.

    "Modified: / 10-05-2011 / 17:09:47 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassReader2 methodsFor:'logging'!

info: string 
    Verbose ifTrue: [Transcript showCR: string].

    "Created: / 10-05-2011 / 12:31:50 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaClassReader2 class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !

JavaClassReader2 initialize!
