"{ Package: 'stx:libjava' }"

Object subclass:#JavaConstantPoolContent
	instanceVariableNames:'owner constantPool'
	classVariableNames:''
	poolDictionaries:''
	category:'Languages-Java-Reader-Support-new'
!


!JavaConstantPoolContent methodsFor:'accessing'!

constantPool
^constantPool.

    "Created: / 10-05-2011 / 17:16:23 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

constantPool: aJavaConstantPool
    constantPool := aJavaConstantPool.

    "Created: / 10-05-2011 / 17:16:37 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

isResolved
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility
!

owner
    ^ owner
!

owner:something
    owner := something.
! !

!JavaConstantPoolContent methodsFor:'logging'!

info: arg 
    Transcript show: arg printString.

    "Created: / 10-05-2011 / 16:50:48 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

warning: arg 
    Transcript show: arg printString.

    "Created: / 10-05-2011 / 15:01:08 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaConstantPoolContent methodsFor:'private - resolving'!

findResolvedStaticValue
    "Resolve reference and set valueCache."
    
    self subclassResponsibility.

    "Created: / 26-04-2011 / 13:19:15 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
!

findResolvedValue
    "Resolve reference and set valueCache."
    
    self subclassResponsibility.

    "Created: / 08-04-2011 / 11:33:28 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
    "Modified: / 26-04-2011 / 13:19:44 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaConstantPoolContent methodsFor:'queries'!

isJavaConstantPoolContent
^true.

    "Created: / 10-05-2011 / 17:18:11 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaConstantPoolContent methodsFor:'resolving'!

invalidate
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility
!

invalidateForClass:arg
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility
!

resolve
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility
!

resolveStatic
    "raise an error: must be redefined in concrete subclass(es)"

    ^ self subclassResponsibility
!

updateClassRefsFrom: oldOwner to: newOwner 
    owner = oldOwner ifTrue: [ owner := newOwner. ].
    self info: 'updating class refs from: ' , oldOwner printString , ' to ' 
                , newOwner printString.

    "Created: / 10-05-2011 / 16:50:48 / Marcel Hlopko <hlopkmar@fel.cvut.cz>"
! !

!JavaConstantPoolContent class methodsFor:'documentation'!

version_SVN
    ^ '$Id$'
! !
